(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("loam", [], factory);
	else if(typeof exports === 'object')
		exports["loam"] = factory();
	else
		root["loam"] = factory();
})(self, () => {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./src/api.js":
/*!********************!*\
  !*** ./src/api.js ***!
  \********************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.initialize = initialize;
exports.open = open;
exports.rasterize = rasterize;
exports.reproject = reproject;
exports.reset = reset;

var _workerCommunication = __webpack_require__(/*! ./workerCommunication.js */ "./src/workerCommunication.js");

var _gdalDataset = __webpack_require__(/*! ./gdalDataset.js */ "./src/gdalDataset.js");

function open(file) {
  var sidecars = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  return new Promise(function (resolve, reject) {
    var ds = new _gdalDataset.GDALDataset(new _gdalDataset.DatasetSource('GDALOpen', file, sidecars));
    return ds.open().then(function () {
      return resolve(ds);
    }, function (reason) {
      return reject(reason);
    });
  });
}

function rasterize(geojson, args) {
  return new Promise(function (resolve, reject) {
    resolve(new _gdalDataset.GDALDataset(new _gdalDataset.DatasetSource('GDALRasterize', geojson, [], args)));
  });
}

function reproject(fromCRS, toCRS, coords) {
  var xCoords = new Float64Array(coords.map(function (pair) {
    return pair[0];
  }));
  var yCoords = new Float64Array(coords.map(function (pair) {
    return pair[1];
  }));
  return (0, _workerCommunication.runOnWorker)('LoamReproject', [fromCRS, toCRS, xCoords, yCoords]);
}

function initialize(loamPrefix, gdalPrefix) {
  return (0, _workerCommunication.initWorker)(loamPrefix, gdalPrefix);
}

function reset() {
  return (0, _workerCommunication.clearWorker)();
}

/***/ }),

/***/ "./src/gdalDataset.js":
/*!****************************!*\
  !*** ./src/gdalDataset.js ***!
  \****************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.GDALDataset = exports.DatasetSource = exports.DatasetOperation = void 0;

var _workerCommunication = __webpack_require__(/*! ./workerCommunication.js */ "./src/workerCommunication.js");

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// A function, to be executed within the GDAL webworker context, that outputs a dataset.
var DatasetOperation = /*#__PURE__*/_createClass(function DatasetOperation(functionName, args) {
  _classCallCheck(this, DatasetOperation);

  this.func = functionName;
  this.args = args;
}); // The starting point of a dataset within a GDAL webworker context. Outputs a dataset.
// - functionName is the name of a GDAL function that can generate a dataset
//   Currently, this is either GDALOpen or GDALRasterize
// - file is a File, Blob, or {name: string, data: Blob}
// - sidecars are any other files that need to get loaded into the worker filesystem alongside file
//   Must match the type of file
// - args are any additional arguments that should be passed to functionName.


exports.DatasetOperation = DatasetOperation;

var DatasetSource = /*#__PURE__*/_createClass(function DatasetSource(functionName, file) {
  var sidecars = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var args = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];

  _classCallCheck(this, DatasetSource);

  this.func = functionName;
  this.src = file;
  this.sidecars = sidecars;
  this.args = args;
});

exports.DatasetSource = DatasetSource;

var GDALDataset = /*#__PURE__*/function () {
  function GDALDataset(source, operations) {
    _classCallCheck(this, GDALDataset);

    this.source = source;

    if (operations && operations.length > 0) {
      this.operations = operations;
    } else {
      this.operations = [];
    }
  } // Does "nothing", but triggers the dataset to be opened and immediately closed with GDAL, which
  // will fail if the file is not a recognized format.


  _createClass(GDALDataset, [{
    key: "open",
    value: function open() {
      return (0, _workerCommunication.accessFromDataset)(undefined, this);
    }
  }, {
    key: "bytes",
    value: function bytes() {
      return (0, _workerCommunication.accessFromDataset)('LoamReadBytes', this);
    }
  }, {
    key: "count",
    value: function count() {
      return (0, _workerCommunication.accessFromDataset)('GDALGetRasterCount', this);
    }
  }, {
    key: "layerCount",
    value: function layerCount() {
      return (0, _workerCommunication.accessFromDataset)('GDALDatasetGetLayerCount', this);
    }
  }, {
    key: "width",
    value: function width() {
      return (0, _workerCommunication.accessFromDataset)('GDALGetRasterXSize', this);
    }
  }, {
    key: "height",
    value: function height() {
      return (0, _workerCommunication.accessFromDataset)('GDALGetRasterYSize', this);
    }
  }, {
    key: "wkt",
    value: function wkt() {
      return (0, _workerCommunication.accessFromDataset)('GDALGetProjectionRef', this);
    }
  }, {
    key: "transform",
    value: function transform() {
      return (0, _workerCommunication.accessFromDataset)('GDALGetGeoTransform', this);
    }
  }, {
    key: "bandMinimum",
    value: function bandMinimum(bandNum) {
      return (0, _workerCommunication.accessFromDataset)('GDALGetRasterMinimum', this, bandNum);
    }
  }, {
    key: "bandMaximum",
    value: function bandMaximum(bandNum) {
      return (0, _workerCommunication.accessFromDataset)('GDALGetRasterMaximum', this, bandNum);
    }
  }, {
    key: "bandStatistics",
    value: function bandStatistics(bandNum) {
      return (0, _workerCommunication.accessFromDataset)('GDALGetRasterStatistics', this, bandNum);
    }
  }, {
    key: "bandDataType",
    value: function bandDataType(bandNum) {
      return (0, _workerCommunication.accessFromDataset)('GDALGetRasterDataType', this, bandNum);
    }
  }, {
    key: "bandNoDataValue",
    value: function bandNoDataValue(bandNum) {
      return (0, _workerCommunication.accessFromDataset)('GDALGetRasterNoDataValue', this, bandNum);
    }
  }, {
    key: "convert",
    value: function convert(args) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        resolve(new GDALDataset(_this.source, _this.operations.concat(new DatasetOperation('GDALTranslate', args))));
      });
    }
  }, {
    key: "vectorConvert",
    value: function vectorConvert(args) {
      var _this2 = this;

      return new Promise(function (resolve, reject) {
        resolve(new GDALDataset(_this2.source, _this2.operations.concat(new DatasetOperation('GDALVectorTranslate', args))));
      });
    }
  }, {
    key: "warp",
    value: function warp(args) {
      var _this3 = this;

      return new Promise(function (resolve, reject) {
        resolve(new GDALDataset(_this3.source, _this3.operations.concat(new DatasetOperation('GDALWarp', args))));
      });
    }
  }, {
    key: "render",
    value: function render(mode, args, colors) {
      var _this4 = this;

      return new Promise(function (resolve, reject) {
        // DEMProcessing requires an auxiliary color definition file in some cases, so the API
        // can't be easily represented as an array of strings. This packs the user-friendly
        // interface of render() into an array that the worker communication machinery can
        // easily make use of. It'll get unpacked inside the worker. Yet another reason to use
        // something like comlink (#49)
        var cliOrderArgs = [mode, colors].concat(args);
        resolve(new GDALDataset(_this4.source, _this4.operations.concat(new DatasetOperation('GDALDEMProcessing', cliOrderArgs))));
      });
    }
  }, {
    key: "close",
    value: function close() {
      return new Promise(function (resolve, reject) {
        var warningMsg = 'It is not necessary to call close() on a Loam dataset. This is a no-op';
        console.warn(warningMsg);
        resolve([]);
      });
    }
  }]);

  return GDALDataset;
}();

exports.GDALDataset = GDALDataset;

/***/ }),

/***/ "./src/index.js":
/*!**********************!*\
  !*** ./src/index.js ***!
  \**********************/
/***/ ((module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = void 0;

var _api = __webpack_require__(/*! ./api.js */ "./src/api.js");

var _gdalDataset = __webpack_require__(/*! ./gdalDataset.js */ "./src/gdalDataset.js");

var _default = {
  open: _api.open,
  rasterize: _api.rasterize,
  GDALDataset: _gdalDataset.GDALDataset,
  initialize: _api.initialize,
  reset: _api.reset,
  reproject: _api.reproject
};
exports["default"] = _default;
module.exports = exports.default;

/***/ }),

/***/ "./src/randomKey.js":
/*!**************************!*\
  !*** ./src/randomKey.js ***!
  \**************************/
/***/ ((module, exports) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports["default"] = randomKey;

// https://stackoverflow.com/questions/10726909/random-alpha-numeric-string-in-javascript
function randomKey() {
  var length = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 32;
  var chars = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '0123456789abcdefghijklmnopqrstuvwxyz';
  var result = '';

  for (var i = length; i > 0; i--) {
    result += chars[Math.floor(Math.random() * chars.length)];
  }

  return result;
}

module.exports = exports.default;

/***/ }),

/***/ "./src/workerCommunication.js":
/*!************************************!*\
  !*** ./src/workerCommunication.js ***!
  \************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {



Object.defineProperty(exports, "__esModule", ({
  value: true
}));
exports.accessFromDataset = accessFromDataset;
exports.clearWorker = clearWorker;
exports.initWorker = initWorker;
exports.runOnWorker = runOnWorker;

var _randomKey = _interopRequireDefault(__webpack_require__(/*! ./randomKey.js */ "./src/randomKey.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var messages = {};
var workerPromise;

var LoamWorker = /*#__PURE__*/_createClass( // Warning: Here be dragons.
//
// In order to run Loam from a CDN, we need to be able to load the worker code from an arbitrary
// prefix, and the GDAL assets from another, potentially different, prefix, determined at
// runtime.  The only way to instantiate a Web Worker is by providing it the URL of a Javascript
// source file, and the only way to specify which prefix the Emscripten wrapper code uses to
// download GDAL's assets is to set Module.locateFile from inside the Web Worker. Once the Web
// Worker has been created, we can only communicate with it via message-passing. Therefore, if
// we used a static file to instantiate the Web Worker, we'd have to have a multi-stage
// initialization process, where the worker asks the main thread which URLs to use to download
// the GDAL assets, sets Module.locateFile appropriately, loads GDAL, and then reports back to
// the main thread that it's ready. This seems potentially error-prone because if something goes
// wrong partway through the process, Loam could get stuck in a half-initialized state and
// potentially would appear to simply "hang" from the user's perspective.
//
// Instead, we are using something of a hack: we generate a string representing Javascript
// source, with the appropriate prefixes baked in. Then we generate a Blob from that string and
// call URL.createObjectURL from the blob. This gives us a URL that we can use to instantiate
// the web worker, but we have immediate control over what it does because we inject the
// prefixes directly into the worker source code via template literals.  However, generating
// Javascript from a string is far from optimal -- it can't be minified, linted, or type-checked
// if we ever convert to Typescript.
//
// The logic in this section should be limited to functionality that absolutely must be
// parameterized upon Worker initialization. Everything else should go in worker.js.
function LoamWorker(loamPrefix, gdalPrefix) {
  _classCallCheck(this, LoamWorker);

  var codeStr = "{\n            // Set up most of Module, and the rest of the worker communication logic.\n            importScripts('".concat(loamPrefix, "' + 'loam-worker.js');\n            // Add locateFile that directs to gdalPrefix\n            self.Module.locateFile = function(path) {\n                return '").concat(gdalPrefix, "' + path;\n            };\n            // Load gdal.js. This will populate the Module object, and then call\n            // Module.onRuntimeInitialized() when it is ready for user code to interact with it.\n            importScripts('").concat(gdalPrefix, "' + 'gdal.js');\n        }");
  var blob = new Blob([codeStr], {
    type: 'application/javascript'
  });
  return new Worker(URL.createObjectURL(blob));
}); // Cache the currently executing script at initialization so that we can use it later to figure
// out where all the other scripts should be pulled from


var _scripts = document.getElementsByTagName('script');

var THIS_SCRIPT = _scripts[_scripts.length - 1]; // Inspired by Emscripten's method for doing the same thing

function getPathPrefix() {
  var prefix = THIS_SCRIPT.src.substring(0, THIS_SCRIPT.src.lastIndexOf('/')) + '/';

  try {
    // prefix must be a valid URL so validate that it is before returning
    // eslint-disable-next-line no-new
    new URL(prefix);
    return prefix;
  } catch (error) {
    // Returning undefined will require the user to specify a valid absolute URL for loamPrefix
    // at least
    return undefined;
  }
} // Destroy the worker and clear the promise so that calling initWorker will make a new one.


function clearWorker() {
  return new Promise(function (resolve) {
    if (workerPromise !== undefined) {
      // If a worker has been initialized, wait for it to succeed or fail. If it succeeds,
      // kill it. Then, no matter what, set the promise to undefined so that subsequent calls
      // to initialize() will spawn a new worker.
      workerPromise.then(function (worker) {
        worker.terminate();
      }) // No need to take any action if initialization fails -- initWorker() will have
      // already torn things down in that case.
      ["finally"](function () {
        workerPromise = undefined;
        resolve();
      });
    } else {
      resolve();
    }
  });
} // Set up a WebWorker and an associated promise that resolves once it's ready


function initWorker(loamPrefix, gdalPrefix) {
  var defaultPrefix = getPathPrefix(); // URL's relative path handling does the "right" thing for all relative paths. That is, if a
  // user passes in an absolute URL with a domain name, it will use the specified domain, but if a
  // path is passed in, it will just override the path and use the prefix domain.
  // https://developer.mozilla.org/en-US/docs/Web/API/URL/URL

  loamPrefix = loamPrefix !== undefined ? new URL(loamPrefix, defaultPrefix).href : defaultPrefix;
  gdalPrefix = gdalPrefix !== undefined ? new URL(gdalPrefix, defaultPrefix).href : loamPrefix;

  if (workerPromise === undefined) {
    workerPromise = new Promise(function (resolve, reject) {
      var _worker = new LoamWorker(loamPrefix, gdalPrefix); // The worker needs to do some initialization, and will send a message when it's ready.
      // The message will specify msg.data.ready == true, but that's not really important;
      // during initialization the worker doesn't do any error handling so any errors will
      // bubble up to onerror (and an error before the "ready" message arrives implies that
      // the ready message will never arrive, so we need to destroy the whole worker).


      _worker.onmessage = function (msg) {
        // Once the worker's ready, change the onMessage and onError functions to handle
        // normal operations.
        _worker.onmessage = function (msg) {
          // Execute stored promise resolver by message ID
          // Promise resolvers are stored by callWorker().
          if (msg.data.success) {
            messages[msg.data.id][0](msg.data.result);
          } else {
            messages[msg.data.id][1](new Error(msg.data.message));
          }

          delete messages[msg.data.id];
        }; // Once the worker is successfully initialized, it handles GDAL errors internally,
        // so we no longer want to do anything special for error handling.


        _worker.onerror = null;
        resolve(_worker);
      }; // Error handler during initialization. This will get overridden upon successful worker
      // initialization. We assume that an error during initialization is fatal, so tear down
      // the worker if that happens.


      _worker.onerror = function (err) {
        err.preventDefault();
        console.error(err);

        _worker.terminate();

        reject(err);
      };
    });
  }

  return workerPromise;
} // Store a listener function with a key so that we can associate it with a message later.


function addMessageResolver(callback, errback) {
  var key = (0, _randomKey["default"])();

  while (messages.hasOwnProperty(key)) {
    key = (0, _randomKey["default"])();
  }

  messages[key] = [callback, errback];
  return key;
} // Send a message to the worker and return a promise that resolves / rejects when a message with
// a matching id is returned.


function workerTaskPromise(options) {
  return initWorker().then(function (worker) {
    return new Promise(function (resolve, reject) {
      var resolverId = addMessageResolver(function (workerResult) {
        return resolve(workerResult);
      }, function (reason) {
        return reject(reason);
      });
      worker.postMessage(_objectSpread({
        id: resolverId
      }, options));
    });
  });
} // Accessors is a list of accessors operations to run on the dataset defined by dataset.


function accessFromDataset(accessor, dataset) {
  for (var _len = arguments.length, otherArgs = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
    otherArgs[_key - 2] = arguments[_key];
  }

  return workerTaskPromise({
    accessor: accessor,
    dataset: dataset,
    args: otherArgs
  });
} // Run a single function on the worker.


function runOnWorker(func, args) {
  return workerTaskPromise({
    func: func,
    args: args
  });
}

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __webpack_require__("./src/index.js");
/******/ 	
/******/ 	return __webpack_exports__;
/******/ })()
;
});
//# sourceMappingURL=loam.js.map